From 6fa00b6f9be351bc231743b43a8e925d2245bc63 Mon Sep 17 00:00:00 2001
From: Remy DeCausemaker <decause@redhat.com>
Date: Jun 07 2015 21:29:34 +0000
Subject: [PATCH 90/254] Added fedmsgstats widget, WIP


---

diff --git a/hubs/defaults.py b/hubs/defaults.py
index da41b82..7a2a619 100644
--- a/hubs/defaults.py
+++ b/hubs/defaults.py
@@ -26,13 +26,19 @@ def add_user_widgets(session, hub, username, fullname):
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='workflow.pendingacls', index=1,
+        plugin='fedmsgstats', index=1,
         _config=json.dumps({
             'username': username,
         }))
     hub.widgets.append(widget)
     widget = hubs.models.Widget(
-        plugin='badges', index=2,
+        plugin='workflow.pendingacls', index=2,
+        _config=json.dumps({
+            'username': username,
+        }))
+    hub.widgets.append(widget)
+    widget = hubs.models.Widget(
+        plugin='badges', index=3,
         _config=json.dumps({
             'username': username,
         }))
diff --git a/hubs/widgets/__init__.py b/hubs/widgets/__init__.py
index 2bb8570..b00af22 100644
--- a/hubs/widgets/__init__.py
+++ b/hubs/widgets/__init__.py
@@ -6,6 +6,7 @@ from hubs.widgets import about
 from hubs.widgets import avatar
 from hubs.widgets import badges
 from hubs.widgets import fedmsgs
+from hubs.widgets import fedmsgstats
 
 from hubs.widgets.workflow import pendingacls
 
@@ -20,6 +21,7 @@ registry = {
     'avatar': avatar,
     'badges': badges,
     'fedmsgs': fedmsgs,
+    'fedmsgstats': fedmsgstats,
     'workflow.pendingacls': pendingacls,
 }
 
diff --git a/hubs/widgets/fedmsgstats.py b/hubs/widgets/fedmsgstats.py
new file mode 100644
index 0000000..e248a8c
--- /dev/null
+++ b/hubs/widgets/fedmsgstats.py
@@ -0,0 +1,38 @@
+from hubs.widgets.chrome import panel
+
+import jinja2
+
+import requests
+
+chrome = panel()
+template = jinja2.Template("""
+<div class="stats-container">
+  <table class="stats-table">
+    <tr><th>FedMsgs</th><th>Subscribers</th></tr>
+    <tr class="text-info"><td>{{fedmsgs}}</td><td>{{subscribers}}</td></tr>
+  </table>
+  <div class="pull-right"><button class="btn btn-info">Subscribe</button></div>
+</div>
+""")
+
+
+def data(session, widget, username):
+    url = "https://apps.fedoraproject.org/datagrepper/raw?user={username}"
+    url = url.format(username=username)
+    response = requests.get(url)
+    fedmsgs = response.json()['total']
+    return dict(
+        fedmsgs=fedmsgs,
+        subscribers=len(widget.hub.subscribers),
+    )
+
+
+# TODO -- add topic-based hinting here.  Solved.
+def should_invalidate(message, session, widget):
+    if message['topic'].endswith('hubs.hub.update'):
+        if message['msg']['hub']['name'] == widget.hub.name:
+            return True
+
+    # TODO -- also check for FAS group changes??  are we doing that?
+
+    return False

